% pdflatex --shell-escape myfile.tex
% pdfcrop --margin 5 myfile.pdf myfile2.pdf
% pdf2svg myfile2.pdf myfile.svg

\documentclass{article}

\usepackage{fontspec}
\usepackage[frenchb]{babel}
\usepackage{wasysym}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage[export]{adjustbox}

\usepackage{tikz}
\usetikzlibrary{shapes,snakes}
\usetikzlibrary{calc}
\makeatletter
\newcommand{\gettikzxy}[3]{%
    \tikz@scan@one@point\pgfutil@firstofone#1\relax
    \edef#2{\the\pgf@x}%
    \edef#3{\the\pgf@y}%
}
\makeatother

\begin{document}
\thispagestyle{empty}

\begin{tikzpicture}[thick,font=\tiny]
    % thread 1
    \node () at (-1, 1) {thread 1};
    \draw[->] (-0.2, 1) to (8, 1) node {};
    \node[draw,fill=blue!50,minimum height=5mm,minimum width=10mm,xshift=5mm,yshift=10mm] () {};
    \node[draw,fill=white,minimum height=5mm,minimum width=20mm,xshift=20mm,yshift=10mm] (A1) {attente réponse};
    \node[draw,fill=blue!50,minimum height=5mm,minimum width=4mm,xshift=32mm,yshift=10mm] (A2) {};
    \node[draw,fill=white,minimum height=5mm,minimum width=16mm,xshift=42mm,yshift=10mm] (A3) {att. appel};
    \node[draw,fill=white,minimum height=5mm,minimum width=20mm,xshift=60mm,yshift=10mm] (A4) {att. réponse};
    % systeme
    \node () at (-1, 0) {système};
    \draw[->] (-0.2, 0) to (8, 0) node {};
    \node[draw,fill=yellow!50,minimum height=5mm,minimum width=20mm,xshift=20mm,yshift=0mm] (R1) {rand()};
    \node[draw,fill=yellow!50,minimum height=5mm,minimum width=20mm,xshift=40mm,yshift=0mm] (R2) {rand()};
    \node[draw,fill=yellow!50,minimum height=5mm,minimum width=20mm,xshift=60mm,yshift=0mm] (R3) {rand()};
    % thread 2
    \node () at (-1, -1) {thread 2};
    \draw[->] (-0.2, -1) to (8, -1) node {};
    \node[draw,fill=blue!50,minimum height=5mm,minimum width=10mm,xshift=5mm,yshift=-10mm] () {};
    \node[draw,fill=white,minimum height=5mm,minimum width=20mm,xshift=20mm,yshift=-10mm] (B1) {attente appel};
    \node[draw,fill=white,minimum height=5mm,minimum width=20mm,xshift=40mm,yshift=-10mm] () {att. réponse};
    \node[draw,fill=blue!50,minimum height=5mm,minimum width=4mm,xshift=52mm,yshift=-10mm] (B2) {};
    \node[draw,fill=white,minimum height=5mm,minimum width=16mm,xshift=62mm,yshift=-10mm] () {att. appel};
    % reponse
    \draw[->] (A1.south west) to (R1.north west) node {};
    \draw[<-] (A2.south west) to (R2.north west) node {};
    \draw[->] (B1.north east) to (R1.south east) node {};
    \draw[<-] (B2.north west) to (R3.south west) node {};
    \draw[->] (A3.south east) to (R2.north east) node {};
    \draw[<-] (A4.south east) to (R3.north east) node {};
\end{tikzpicture}

\end{document}

